%=============================================================================
% HEBBIAN linear classifier object             
%=============================================================================  
% a=hebbian(hyper) 
%
% Generates a hebbian classication object.
%
% Model: f(X) = X*W' + b0
%    W                   -- the weights
%    b0                  -- the bias
%
% Hyperparameter:
%    verbosity              -- 0/1 flag
%    test_on_training_data  -- 0/1 flag (faster if 0)
%
% Methods:
%  train, test

%Isabelle Guyon -- isabelle@clopinet.com -- November 2010

classdef hebbian < linear_template
     % This is a derived class
     methods
        %%%%%%%%%%%%%%%%%%%
        %%% CONSTRUCTOR %%%
        %%%%%%%%%%%%%%%%%%%
        function a = hebbian(hyper) 
            if nargin<1, hyper=[]; end
            a=a@linear_template(hyper);
        end         
    end
end
  

 

 
 





