function data = test(model, data)
%data = test(model, data)
% You should not overload this function: keep as is!
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make predictions with a linear discriminant method.
% Inputs:
% model -- A linear discriminant model.
% data -- A data structure.
% Returns:
% data -- The same data structure, but X is replaced by the discriminant
% values, Y remains untouched. WARNING: this follows the convention of
% Spider http://www.kyb.mpg.de/bs/people/spider/ objects and may be counter
% intuitive. *** The result is in data.X!!!! ***

% Isabelle Guyon -- November 2010 -- isabelle@clopinet.com

if model.verbosity>0, fprintf('==> Testing %s... ', class(model)); end

[p, n]=size(data.X);

if n~=length(model.W), 
    Yest=[];
else
    Yest = data.X*model.W' + model.b0(ones(p,1),:);
end

% Remove ties (the negative class is usually most abundant):
zero_val=find(Yest==0);
Yest(zero_val)=-1*eps; 

data.X=Yest; 

if model.verbosity>0, fprintf('done\n'); end