function d = test(a, d)
%d = test(a, d)
% This does it all. There is no model...
% Inputs:
% a -- A sp model.
% d -- A data structure.
% Returns:
% d -- The same data structure, but X is replaced by the preprocessed data.

% Isabelle Guyon -- Dec 2010 -- isabelle@clopinet.com

if a.verbosity>0
    fprintf('==> sp preprocessing... ');
end

% Determining the number of features.:
if isempty(a.fnum)
    a.fnum=size(d.X, 1);
end
n=min(round(sqrt(2*a.fnum)), size(d.X, 2));

% Finding features of high variance
v= var(d.X);
[s, i]=sort(-v);
x=d.X(:, i(1:n));

% Creating the products
u=1:n;
m1=u(ones(n, 1), :);
m2=m1';
id1=m1(:);
id2=m2(:);
p=x(:, id1).*x(:, id2);

% Adding the raw data.
d.X=[x p];

if a.verbosity>0
    fprintf('done\n');
end