function [X, Y, p]=create_data_structure(the_data_dir, data_name, set_name)
%[X, Y]=create_data_structure(the_data_dir, data_name, set_name)

% Isabelle Guyon -- isabelle@clopinet.com -- November 2010

X=[];
Y=[];
p=[];

param_file=[the_data_dir '/' data_name '.param'];
if exist(param_file, 'file')
    p   = read_param(param_file);
    print_param(p);
end

for i=1:length(set_name)
    X.(set_name{i})=load_data(the_data_dir, data_name, set_name{i}, p);
end

label_file=[the_data_dir data_name '_transfer.label'];
% Load the transfer learning labels (if available)
if exist(label_file, 'file')
    fprintf('==> Loading labels... ');
    Y.devel=load(label_file);
    fprintf('done\n');
    fprintf('Number of transfer labels = %d\n', length(find(sum(Y.devel,2)~=0)));
end

X.quantized=0;
X.kernelized=0;