function D = data_struct(X, Y)
%D = data_struct(X, Y)
% Constructs a data structure D.X, D.Y using either a simple
% structure of the data objects available.
if nargin<2, Y=[]; end
X=double(X);
if exist('data_object', 'file') == 2
	D=data_object(X, Y); % Sample data object
elseif exist('data', 'file') == 2
	D=data(X, Y); % Spider data object
else
    D=struct('X', X, 'Y', Y);
end

