function X = kernelize( X )
%X = kernelize( X )
%   replace X by X*X'

% Isabelle Guyon -- isabelle@clopinet.com -- November 2010

f=fields(X);

fprintf('==> Kernelizing...');
for i=1:length(f)
    % Change that if you need to kernelize the development data
    if ~(strcmp(f{i}, 'devel') || strcmp(f{i}, 'kernelized') || strcmp(f{i}, 'quantized')) % Do not kernelize development data, too big
        M=double(X.(f{i}));
        X.(f{i})=M*M';
        % verify the data is PD
        if ~pd_check(X.(f{i}))
            fprintf('\n==> kernelize: warning, matrix %s data is not pd.', f{i});
            continue;
        end
    end
end
X.kernelized=1;
fprintf(' done\n');

