function X=load_data(datadir, data_name, set_name, p)
%load_data(data_dir, data_name, set_name, p)
% Load the data. Use Matlab format if it exists.

% Author: Isabelle Guyon -- November 2010 -- isabelle@clopinet.com

X=[];
data_name=[data_name '_' set_name];
if exist([datadir '/' data_name '.mat'], 'file') 
    fprintf('==> Loading data %s in Matlab format... ', data_name);
    load([datadir '/' data_name '.mat']);
elseif exist([datadir '/' data_name '.data'], 'file') 
    fprintf('==> Loading data %s in text format... ', data_name);
    X=matrix_data_read([datadir '/' data_name '.data'], p.feat_num, p.([set_name '_num']), p.data_type);
    fprintf('done\n');
    fprintf('==> Saving data %s in Matlab format... ', data_name);
    save([datadir '/' data_name '.mat'], 'X');
else
    fprintf('==> load_data::ERROR: No %s data file in directory %s\n', data_name, datadir);
    return
end

fprintf('done\n');
