function make_zip(preprodir, zipdir, file_name, zip_final_only_if_small)
%make_query(preprodir, zipdir, name, zip_final_only_if_small)
% Zip the preprocessed data files in preprodir.
% Put the zipped file under filename in zipdir.
% Zip the final data only if is is "small"
% name --           Name of the file

% Author: Isabelle Guyon -- November 2010 -- isabelle@clopinet.com

fprintf('==> Zipping %s... ', file_name);

if ~usejava('jvm'),
    fprintf('==> Java is not loaded, failed to generate ZIP files !!!\n'); 
    fn=[];
    return
end

D=dir([preprodir sl file_name '_*.prepro']);
[resu_files{1:length(D)}] = deal(D.name);
resu_files=setdiff(resu_files, [file_name '.zip']);

kfinal=[];
for k=1:length(resu_files)
    if ~isempty(strfind(resu_files{k}, '_final.prepro'))
    kfinal=k;
    end
end
if ~isempty(kfinal)
    if D(kfinal).bytes>10000000
        fprintf('(skipping %s, too big) ', resu_files{kfinal});
        resu_files=setdiff(resu_files, resu_files{kfinal});
    end
end
        
zip([zipdir sl file_name], resu_files, preprodir);

fn=[zipdir sl file_name '.zip'];

fprintf('done,\n    see: %s\n', fn); 