function X_norm = normalize_data(X, norm, add_fudge)
%X_norm = normalize_data(X, norm, add_fudge)
% For each pattern, divide by the sum of the absolute values
% or by the Euclidean norm.

% Isabelle Guyon -- isabelle@clopinet.com -- November 2010

if nargin<2, norm=1; end
if nargin<3, add_fudge=1; end
    
if norm==1
    norma_vec=sum(abs(X),2);
elseif norm==2
    norma_vec=sqrt(sum(X.*X,2));
else
    fprintf('data_struct::normalize: norm not supported');
end
if add_fudge
    fudge=median(norma_vec);
else
    fudge=0;
end

X_norm=X./(eps+fudge+norma_vec(:, ones(size(X,2),1)));


