function XP=preprocess_data(ml_algo, X, Y);  
%XP=preprocess_data(ml_algo, X, Y);  
%Use ml_algo (an algorithm object) to preprocess the data

% Isabelle Guyon -- isabelle@clopinet.com -- November 2010

% Note 1: one can use devel, eval or everything at once.
% Note 2: the transfer learning labels are not used.

prepro_option='valid'; % 'devel', 'valid', 'eval', or 'all'

fprintf('==> Training preprocessing model %s... ', ml_algo);
switch prepro_option
    case 'devel'
        [d, m]=train(eval(ml_algo), data_struct(X.devel));
    case 'valid'
        [d, m]=train(eval(ml_algo), data_struct(X.valid));
    case 'eval'
        [d, m]=train(eval(ml_algo), data_struct([X.valid;X.final]));
    case 'all'
        [d, m]=train(eval(ml_algo), data_struct([X.devel;X.valid;X.final]));
end
fprintf('done\n==> Preprocessing validation set... ');
d=test(m, data_struct(X.valid));
XP.valid=d.X;
fprintf('done\n');

if isfield(X, 'final')
    fprintf('==> Preprocessing final evaluation set ');
    if strcmp(prepro_option, 'eval') 
        [d, m]=train(eval(ml_algo), data_struct(X.final));
    end
    d=test(m, data_struct(X.final));
    XP.final=d.X;
    fprintf('done\n');
end
XP.kernelized=0;
XP.quantized=0;

