function print_param(p, filename)
%print_param(p, filename)
% Print dataset parameters and statistics

% Isabelle Guyon -- August 2003 -- isabelle@clopinet.com

if nargin<2, 
    fp=1; 
else
    fp=fopen(filename, 'w');
end

fprintf(fp, 'Number of features: %d\n', p.feat_num);
fprintf(fp, 'Number of examples and check-sums:\n');
fprintf(fp, '     \tTot_ex\tCheck_sum\n');
fprintf(fp, 'Devel\t%5d\t', ...
    p.devel_num);
if isfield(p, 'devel_check_sum')
    fprintf(fp, '%5.2f\n', p.devel_check_sum);
else
    fprintf(fp, '\n');
end
fprintf(fp, 'Valid\t%5d\t', ...
     p.valid_num);
if isfield(p, 'valid_check_sum')
    fprintf(fp, '%5.2f\n', p.valid_check_sum);
else
    fprintf(fp, '\n');
end
fprintf(fp, 'Final\t%5d\t', ...
    p.final_num);
if isfield(p, 'final_check_sum')
    fprintf(fp, '%5.2f\n', p.final_check_sum);
else
    fprintf(fp, '\n');
end
fprintf(fp, 'All  \t%5d\t', ...
        p.devel_num+p.valid_num+p.final_num);
if isfield(p, 'devel_check_sum')
    fprintf(fp, '%5.2f\n', p.devel_check_sum+p.valid_check_sum+p.final_check_sum);
else
    fprintf(fp, '\n');
end 
if nargin>1,
    fclose(fp);
end