function X = quantize_data( X )
%X = quantize_data( X )
%   quantize data between 0 and 999

% Isabelle Guyon -- isabelle@clopinet.com -- September 2010

f=fields(X);
X.quantized=1;

fprintf('==> Quantizing...');
for i=1:length(f)
    if ~(strcmp(f{i}, 'devel') || strcmp(f{i}, 'kernelized') || strcmp(f{i}, 'quantized')) % Do not treat development data (too big)

        XX=X.(f{i});
        maxi=max(max(XX));
        mini=min(min(XX));
        if all(all(round(XX)==XX)) && maxi<=999
            fprintf('\n==> quantize: Data are integer already, do not quantize.');
            fprintf(' done\n');
            return
        end

        Q=(XX-mini)/(maxi-mini);
        Q=round(Q*999);

        % check whether the matrix is still positive semi-definite
        if X.kernelized && ~pd_check(Q)
            fprintf('\n==> quantize: Warning, quantized %s kernelized data lost its pd property.', f{i});
        end
        X.(f{i})=Q;
    end
end
fprintf(' done\n');


