function p=read_param(filename)
%p=read_param(filename)
% Read dataset parameters and statistics

% Isabelle Guyon -- August 2003 -- isabelle@clopinet.com

if isempty(strfind(filename, '.param'))
    filename=[filename '.param'];
end
fp=fopen(filename, 'r');

p.data_type=fscanf(fp, 'Data type: %s\n');
p.feat_num=fscanf(fp, 'Number of features: %d\n');
fgetl(fp);
fgetl(fp);
m=fscanf(fp, 'Devel\t%d\t%g\n');
if length(m)>1, cs=1; else cs=0; end
p.devel_num=m(1);
if cs, p.devel_check_sum=m(2); end
m=fscanf(fp, 'Valid\t%d\t%g\n');
p.valid_num=m(1);
if cs, p.valid_check_sum=m(2); end
m=fscanf(fp, 'Final\t%d\t%g\n');
p.final_num=m(1);
if cs, p.final_check_sum=m(2); end
m=fscanf(fp, 'All\t%d\t%g\n');
p.all_num=m(1);
if cs, p.all_check_sum=m(2); end

fclose(fp);
