function save_data(dir, name, D)
%save_data(dir, name, D)

% Isabelle Guyon -- isabelle@clopinet.com -- November 2010
% Modified by Gideon Dror, December 2010

f=fields(D);

for i=1:length(f)
    if ~(strcmp(f{i}, 'devel') || strcmp(f{i}, 'kernelized') || strcmp(f{i}, 'quantized')) % Do not save and send development data
        X=full(D.(f{i}));
        filename=[dir sl name '_' f{i} '.prepro'];
        fprintf('==> Saving %s... ', [name '_' f{i} '.prepro']);
        if isinteger(X) || D.quantized
            save_int(filename, X);
        else 
            save(filename, 'X', '-ascii'); 
        end
        fprintf('done\n');
    end
end


function save_int(filename, X);
fid = fopen(filename, 'w');
for i = 1:size(X,1)
    fprintf(fid, '%d ', X(i,:));
    fprintf(fid,'\n');
end
fclose(fid);
return